#include "defs.h"

#ifdef MAC
#include <GLUT/glut.h>
#else
#include <GL/glut.h>
#endif

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>

void init(void);
void display(void);

int main (int argc, char **argv) {
	glutInit(&argc, argv);
	glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGB);
	glutInitWindowSize(XLEN, YLEN);
	glutInitWindowPosition(10, 10);
	glutCreateWindow("Slide Show");
	init();
	glutDisplayFunc(display);
	glutIdleFunc(display);
	glutMainLoop();
	return 0;
}

void init(void) {
	glClearColor(0.0, 0.0, 0.0, 0.0);
	glColor3f(1.0, 1.0, 1.0);
	glMatrixMode(GL_PROJECTION);	
	glLoadIdentity();
	glOrtho(0, XLEN, 0, YLEN, -10.0, 10.0);
	
	load_pbm("miranda.pbm");
}

void Hrotate(void) {
	int x, y;
	short int temp[3];
	
	for (y = 0; y < YLEN; y++) {
		temp[RED] = buffer[0][y][RED];
		temp[GREEN] = buffer[0][y][GREEN];
		temp[BLUE] = buffer[0][y][BLUE];
		for (x = 1; x < XLEN; x++) {
			buffer[x-1][y][RED] = buffer[x][y][RED];
			buffer[x-1][y][GREEN] = buffer[x][y][GREEN];
			buffer[x-1][y][BLUE] = buffer[x][y][BLUE];
		}
		buffer[XLEN-1][y][RED] = temp[RED];
		buffer[XLEN-1][y][GREEN] = temp[GREEN];
		buffer[XLEN-1][y][BLUE] = temp[BLUE];
	}
}

void Vrotate(void) {
	int x, y;
	short int temp[3];
	
	for (x = 0; x < XLEN; x++) {
		temp[RED] = buffer[x][0][RED];
		temp[GREEN] = buffer[x][0][GREEN];
		temp[BLUE] = buffer[x][0][BLUE];
		for (y = 1; y < YLEN; y++) {
			buffer[x][y-1][RED] = buffer[x][y][RED];
			buffer[x][y-1][GREEN] = buffer[x][y][GREEN];
			buffer[x][y-1][BLUE] = buffer[x][y][BLUE];
		}
		buffer[x][YLEN-1][RED] = temp[RED];
		buffer[x][YLEN-1][GREEN] = temp[GREEN];
		buffer[x][YLEN-1][BLUE] = temp[BLUE];
	}
}


void display(void) {
	int x, y;

	Hrotate();		
	Vrotate();
	
	glBegin(GL_POINTS);
	for (x = 0; x < XLEN; x++) {
		for (y = 0; y< YLEN; y++) {
			glColor3f( buffer[x][y][RED]/256.0f, buffer[x][y][GREEN]/256.0f, buffer[x][y][BLUE]/256.0f);
   			glVertex2i(x, YLEN - (y+1));					
		}
	}
	glEnd();

	glutSwapBuffers();
}

void load_pbm(char pbm[]) {
	FILE *fh;
	int x,y;
	char line[200];
	
	fh = fopen(pbm, "rt");
	if (fh == NULL) {
		printf("Error operning file\n");
		exit(1);
	}
	fgets(line, 100, fh);
	fgets(line, 100, fh);
	fgets(line, 100, fh);
	for (y = 0; y < YLEN; y++) {
		for (x = 0 ; x < XLEN; x++) {			
			fscanf(fh, "%hd", &buffer[x][y][RED]);
			fscanf(fh, "%hd", &buffer[x][y][GREEN]);
			fscanf(fh, "%hd", &buffer[x][y][BLUE]);
		}
	}
}
